JUCE: KeyboardFocusTraverser Class Reference

JUCE

Public Member Functions | List of all members
KeyboardFocusTraverser Class Reference

Controls the order in which focus moves between components. More...

## Public Member Functions
| KeyboardFocusTraverser ()
virtual | ~KeyboardFocusTraverser ()
| Destructor. More...
virtual Component * | getNextComponent (Component *current)
| Returns the component that should be given focus after the specified one when moving "forwards". More...
virtual Component * | getPreviousComponent (Component *current)
| Returns the component that should be given focus after the specified one when moving "backwards". More...
virtual Component * | getDefaultComponent (Component *parentComponent)
| Returns the component that should receive focus be default within the given parent component. More...

## Detailed Description

Controls the order in which focus moves between components.

The default algorithm used by this class to work out the order of traversal is as follows:

- if two components both have an explicit focus order specified, then the one with the lowest number comes first (see the Component::setExplicitFocusOrder() method).
- any component with an explicit focus order greater than 0 comes before ones that don't have an order specified.
- any unspecified components are traversed in a left-to-right, then top-to-bottom order.

If you need traversal in a more customised way, you can create a subclass of KeyboardFocusTraverser that uses your own algorithm, and use Component::createFocusTraverser() to create it.

See also
  Component::setExplicitFocusOrder, Component::createFocusTraverser

## Constructor & Destructor Documentation

## ◆ KeyboardFocusTraverser()

KeyboardFocusTraverser::KeyboardFocusTraverser | ( |  | ) |

## ◆ ~KeyboardFocusTraverser()

virtual KeyboardFocusTraverser::~KeyboardFocusTraverser | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getNextComponent()

virtual Component* KeyboardFocusTraverser::getNextComponent | ( | Component * | current | ) |
| virtual

Returns the component that should be given focus after the specified one when moving "forwards".

The default implementation will return the next component which is to the right of or below this one.

This may return nullptr if there's no suitable candidate.

## ◆ getPreviousComponent()

virtual Component* KeyboardFocusTraverser::getPreviousComponent | ( | Component * | current | ) |
| virtual

Returns the component that should be given focus after the specified one when moving "backwards".

The default implementation will return the next component which is to the left of or above this one.

This may return nullptr if there's no suitable candidate.

## ◆ getDefaultComponent()

virtual Component* KeyboardFocusTraverser::getDefaultComponent | ( | Component * | parentComponent | ) |
| virtual

Returns the component that should receive focus be default within the given parent component.

The default implementation will just return the foremost child component that wants focus.

This may return nullptr if there's no suitable candidate.

The documentation for this class was generated from the following file:

- juce_KeyboardFocusTraverser.h